#include<string>
#include<cstdint>
#include"CompoundType.h"

#ifndef LS_BoxedVar_H_
#define LS_BoxedVar_H_
namespace ls {
	struct function_tag {};
	class BoxedVar {
	public:
		BoxedVar() :
			ptr(createVar()) {}
		explicit BoxedVar(bool b):
			ptr(createVar(b)) {}
		explicit BoxedVar(int64_t i) :
			ptr(createVar(i)) {}
		explicit BoxedVar(int i) :
			ptr(createVar(i)) {}
		explicit BoxedVar(double d) :
			ptr(createVar(d)) {}
		explicit BoxedVar(const std::string & str) :
			ptr(createVar(str)) {}
		explicit BoxedVar(const std::string & name, std::unique_ptr<FunctionCode, FunctionCodeDeleter> t) :
			ptr(createVar(name,move(t))) {}
		explicit BoxedVar(std::function<std::shared_ptr<CompoundType>(std::vector<BoxedVar>&)> t, function_tag) :
			ptr(createVar(t)) {}
		BoxedVar(const BoxedVar & var);
		explicit BoxedVar(const std::shared_ptr<CompoundType> & t)
		:ptr(t){}
		explicit BoxedVar(const std::shared_ptr<CompoundType> && t)
			:ptr(std::move(t)) {}

		std::shared_ptr<CompoundType> get() const { return ptr; }
		void set(const std::shared_ptr<CompoundType> & t) { ptr = t; }

		std::string to_string() const { return ptr->to_string(); }
	private:
		std::shared_ptr<CompoundType> ptr;
	};
	inline BoxedVar createBoxedFunction(std::function<std::shared_ptr<CompoundType>(std::vector<BoxedVar>&)> t) {
		return BoxedVar(t, function_tag());
	}
}
#endif