#include "ByteCode.h"

bool ls::isInOpers(code_t c)
{
	switch (c)
	{
	case ls::code_t::and:
	case ls::code_t:: or:
	case ls::code_t::not:
	case ls::code_t::plus:
	case ls::code_t::minus:
	case ls::code_t::add:
	case ls::code_t::sub:
	case ls::code_t::mul:
	case ls::code_t::div:
	case ls::code_t::eq:
	case ls::code_t::neq:
	case ls::code_t::gte:
	case ls::code_t::gt:
	case ls::code_t::less:
	case ls::code_t::leq:
		return true;
	default:
		return false;
	}
}

std::string ls::to_string(code_t t)
{
	static const char * lookup[] = { "nop",
	"and","or","not",
	"plus","minus",
	"add","sub","mul","div",
	"eq","neq","gt","gte","less","leq",
	"push","pop","load","store","new_var",
	"jmp","jt","jf",
	"enterScope","leaveScope",
	"call","ret","ref","getiter","getvalue",
	"isEnd","next",
	};
	if(t != code_t::ERROR)
		return lookup[static_cast<size_t>(t)];
	return "Error";
}
