
#include<cstdint>
#include<vector>
#include<map>
#include"Operators.h"
#include"BoxedVar.h"

#ifndef LS_ByteCode_H_
#define LS_ByteCode_H_
namespace ls {
	typedef int64_t pos_t;
	enum class code_t : uint16_t
	{
		//ƹ͵ .
		nop = 0,
		//ÿ 2 ̾Ƽ and    ÿ .
		and = kAnd,
		//ÿ 2 ̾Ƽ or    ÿ .
		or = kOr,
		//ÿ 2 ̾Ƽ and    ÿ .
		not = kNot,

		//ÿ 1 ̾Ƽ plus    ÿ .
		plus = kPlus,
		//ÿ 1 ̾Ƽ minus    ÿ .
		minus = kMinus,
		//ÿ 2 ̾Ƽ   ÿ .
		add = kAdd,
		//ÿ 2 ̾Ƽ  ÿ .
		sub = kSub,
		//ÿ 2 ̾Ƽ   ÿ .
		mul = kMul,
		//ÿ 2 ̾Ƽ   ÿ .
		div = kDiv,

		//ÿ 2 ̾Ƽ   bool  ÿ .
		eq = kEqual,
		neq = kNotEqual,
		gt = kGreater, 
		gte = kEqualGreater,
		less = kLess,
		leq = kLessEqual,
		
		//ÿ ϳ 
		push,
		//ÿ Ѱ ̾Ƴ.
		pop,
		//ÿ ̸ ޾Ƽ  ǵ ֱ.
		load,
		//ÿ 2 ̾Ƽ ó  Ϳ ߿   ֱ.
		store,
		//ÿ ̸ ޾Ƽ ο  
		new_var,

		// ּ . ProgramCounter  ϸ .
		jmp,
		//ÿ 1 ̾Ƽ ϶ 
		jt,
		//ÿ 1 ̾Ƽ ϶ 
		jf,

		//  .
		enterScope,
		// .
		leaveScope,

		//Լ ȣ
		call,
		// operator []  .   ϴ .
		ref,
		//return
		ret,
		//get iterator from object.
		getiter,
		//get value from iterator.
		getvalue,
		//true if iterator is terminated, otherwise false.
		isEnd,
		//get next sequence iterator.
		next,
		


		ERROR = 0xffff,
	};
	struct instruction {
		code_t code;
		pos_t pos = -1;
	};
	bool isInOpers(code_t c);
	std::string to_string(code_t t);

	struct FunctionCode
	{
		std::vector<instruction> code;
		std::vector<BoxedVar> operands;
	};
	struct InstructionCode {
		FunctionCode mainframe;
		FunctionCode * ptr;
		explicit InstructionCode() {
			ptr = &mainframe;
		}
		
		FunctionCode * operator->() { return ptr; }
		const FunctionCode * operator->() const { return ptr; }
	};
}

#endif