#include "CodeGeneration.h"

std::ostream & ls::operator<<(std::ostream & os, const GenerationContext & gc)
{
	for (auto it : (gc.inst)->code)
	{
		os << to_string(it.code) << "\t";
		if (it.pos >= 0)
		{
			os << (gc.inst)->operands[it.pos].to_string();
		}
		os << "\n";
	}
	return os;
}

void ls::GenerationContext::loopStart()
{
	lpos.emplace_back();
	lpos.back().b = inst->code.size();
}

void ls::GenerationContext::loopEnd()
{
	int64_t e = inst->code.size();
	if (lpos.size() == 0)
		throw std::exception("Depth Error!");
	for (auto it : lpos.back().break_pos)
	{
		set(it.operandPos, BoxedVar(e - it.codePos));
	}
	for (auto it : lpos.back().continue_pos)
	{
		set(it.operandPos, BoxedVar(lpos.back().b - it.codePos));
	}
	lpos.pop_back();
}
