#include<memory>
#include<ostream>
#include"ByteCode.h"
#include "BoxedVar.h"

#ifndef LS_CodeGeneration_H_
#define LS_CodeGeneration_H_
namespace ls {
	class GenerationContext
	{
	public:
		inline void push(code_t c) {
			inst->code.push_back(instruction{ c, -1 });
		}
		inline void push(code_t c, BoxedVar var) {
			inst->operands.push_back(var);
			inst->code.push_back(instruction{ c, static_cast<int64_t>(inst->operands.size() - 1 )});//error .  .
		}
		inline int64_t currentPos() { return inst->operands.size() - 1; }
		inline void set(int64_t pos, BoxedVar var) { inst->operands[pos] = var; }

		inline int64_t currentCodePos() { return inst->code.size() - 1; }
		//inline int64_t setCodePos(int64_t pos, code_t c) { inst->code[pos].code = c; }

		void loopStart();
		void loopEnd();
		
		
		int registerBreak() { 
			push(code_t::push, BoxedVar());
			lpos.back().break_pos.push_back({ currentCodePos() + 1,currentPos() });
			push(code_t::jmp);
			return 2;
		}
		int registerContinue() {
			push(code_t::push, BoxedVar());
			lpos.back().continue_pos.push_back({ currentCodePos() + 1,currentPos() });
			push(code_t::jmp);
			return 2;
		}
		void setFrame(FunctionCode * t) {
			inst.ptr = t;
		}
		FunctionCode * getFrame() { return inst.ptr; }
		friend std::ostream & operator<<(std::ostream & os, const GenerationContext & a);
	private:
		InstructionCode inst;
		struct LoopPos
		{
			struct CodePos{
				int64_t codePos;
				int64_t operandPos;
			};
			int64_t b;
			std::vector<CodePos> continue_pos;
			std::vector<CodePos> break_pos;
		};
		std::vector<LoopPos> lpos;
	};
	std::ostream & operator<<(std::ostream & os, const GenerationContext & a);
}

#endif